extern "C" {

#ifdef FREEBSD
#include <ncurses.h>
#else
  #include <curses.h>
#endif

  #include <stdio.h>
}
#undef erase
#undef clear
#undef move
#include "common.h"

class Screen {

public:
    Screen( bool );
    ~Screen();

    void newsServer(char *);    // Actual display functions
    void newsgroup(char *);
    void msgID(char *);
    void msgIDlast(char *id);
    void subject(char *);
    void line(char *);
    void lastDecode(char *);
    void encodedAs(char *);
    void addTextToScrollWindow( char *text);
    void percentLeft( float percent );
    void messageProgress( int iCurLine, int iLines );

private:
    bool do_output;
    WINDOW *scrollwindow;

    void fix_string(char *p);
    void clearline(int which);
    void clearline(int which, int to); // Clear line <which> till char <to>
};

